variable "api_token" {
    description = "Cloudflare account API token"
    type        = string
    default     = ""
    sensitive   = true
}

variable "zone_id" {
    description = "The DNS zone id as siplayed in cloudflare dashboard."
    type = string
    default = ""
    sensitive = false
}

variable "dns_records" {
    description = "DNS A records to create"
    type        = list(object({
        name    = string
        type    = string
        content = string
        ttl     = number
    }))
    default     = []
}

variable "mx_records" {
    description = "DNS MX records to create"
    type = list(object({
        name     = string
        type     = string
        content  = string
        priority = number
        ttl      = number
    }))
    default     = []
}

variable "caa_records" {
    description = "DNS CAA records to create"
    type = list(object({
        name     = string
        type     = string
        content  = string
        # priority = number
        ttl      = number
    }))
    default     = []
}