resource "vultr_kubernetes" "k8s" {
  region  = "ewr"
  version = "v1.29.2+1"
  label   = "cluster00"
  ha_controlplanes = false
  enable_firewall = false

  node_pools {
    node_quantity = 1
    plan          = "vc2-2c-2gb"
    label         = "cluster00-worker-2c-2g"
    auto_scaler   = false
  }
}

resource "local_sensitive_file" "kubeconfig" {
  content_base64 = vultr_kubernetes.k8s.kube_config
  filename = pathexpand("~/.kube/vultr")
  file_permission = "0600"
}

# resource "vultr_block_storage" "ssd0" {
#   label = "cluster00-ssd0"
#   size_gb = 10
#   region = "ewr"
#   block_type = "high_perf"
#   attached_to_instance = vultr_kubernetes.k8s.node_pools[0].nodes[0].id
#   live = true
#   depends_on = [
#     vultr_kubernetes.k8s
#   ]
# }

# output "ssd0_mount" {
#   value = vultr_block_storage.ssd0.mount_id
# }
