resource "kubernetes_deployment" "keyoxide" {
  depends_on = [
    kubernetes_config_map.keyoxide-env
  ]
  metadata {
    name = "keyoxide"
    namespace = "default"
  }

  spec {
    replicas = 1

    selector {
      match_labels = {
        app = "keyoxide"
      }
    }

    template {
      metadata {
        labels = {
          app = "keyoxide"
        }
      }

      spec {
        container {
          name  = "keyoxide"
          image = "codeberg.org/keyoxide/keyoxide-web"
          image_pull_policy = "Always"

          resources {
            requests = {
              cpu    = "100m"
              memory = "50Mi"
            }
            limits = {
              cpu    = "500m"
              memory = "128Mi"
            }
          }

          env_from {
            config_map_ref {
              name = "keyoxide-env"
            }
          } 

        }
      }
    }
  }
}
